DCMTK: DcmQueryRetrieveDatabaseHandle Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | List of all members
DcmQueryRetrieveDatabaseHandle Class Referenceabstract

abstract base class for database handles. More...

Inheritance diagram for DcmQueryRetrieveDatabaseHandle:

## Public Member Functions
| DcmQueryRetrieveDatabaseHandle ()
| default constructor
virtual | ~DcmQueryRetrieveDatabaseHandle ()
| Destructor.
virtual OFCondition | makeNewStoreFileName (const char *SOPClassUID, const char *SOPInstanceUID, char *newImageFileName, size_t newImageFileNameLen)=0
| create a filename under which a DICOM object that is currently being received through a C-STORE operation can be stored.
virtual OFCondition | storeRequest (const char *SOPClassUID, const char *SOPInstanceUID, const char *imageFileName, DcmQueryRetrieveDatabaseStatus *status, OFBool isNew=OFTrue)=0
| register the given DICOM object, which has been received through a C-STORE operation and stored in a file, in the database.
virtual OFCondition | startFindRequest (const char *SOPClassUID, DcmDataset *findRequestIdentifiers, DcmQueryRetrieveDatabaseStatus *status)=0
| initiate FIND operation using the given SOP class UID (which identifies the query model) and DICOM dataset containing find request identifiers.
virtual OFCondition | nextFindResponse (DcmDataset **findResponseIdentifiers, DcmQueryRetrieveDatabaseStatus *status, const DcmQueryRetrieveCharacterSetOptions &characterSetOptions)=0
| return the next available FIND response as a new DICOM dataset.
virtual OFCondition | cancelFindRequest (DcmQueryRetrieveDatabaseStatus *status)=0
| cancel the ongoing FIND request, stop and reset every running operation associated with this request, delete existing temporary files.
virtual OFCondition | startMoveRequest (const char *SOPClassUID, DcmDataset *moveRequestIdentifiers, DcmQueryRetrieveDatabaseStatus *status)=0
| initiate MOVE operation using the given SOP class UID (which identifies the retrieve model) and DICOM dataset containing move request identifiers.
virtual OFCondition | nextMoveResponse (char *SOPClassUID, size_t SOPClassUIDSize, char *SOPInstanceUID, size_t SOPInstanceUIDSize, char *imageFileName, size_t imageFileNameSize, unsigned short *numberOfRemainingSubOperations, DcmQueryRetrieveDatabaseStatus *status)=0
| Constructs the information required for the next available C-MOVE sub-operation (the image SOP class UID, SOP Instance UID and an imageFileName containing the requested data).
virtual OFCondition | cancelMoveRequest (DcmQueryRetrieveDatabaseStatus *status)=0
| cancel the ongoing MOVE request, stop and reset every running operation associated with this request, delete existing temporary files.
virtual OFCondition | pruneInvalidRecords ()=0
| Prune invalid records from the database.
virtual void | setIdentifierChecking (OFBool checkFind, OFBool checkMove)=0
| Configure the DB module to perform (or not perform) checking of FIND and MOVE request identifiers.

## Detailed Description

abstract base class for database handles.

A database handle maintains a connection to a database and encapsulates database support for store, find and move/get operations.

## Constructor & Destructor Documentation

## ◆ ~DcmQueryRetrieveDatabaseHandle()

virtual DcmQueryRetrieveDatabaseHandle::~DcmQueryRetrieveDatabaseHandle | ( |  | ) |
| virtual

Destructor.

Destroys handle, cancels any ongoing request if necessary, deletes temporary files used for C-STORE and sub-operations of C-MOVE.

## Member Function Documentation

## ◆ cancelFindRequest()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::cancelFindRequest | ( | DcmQueryRetrieveDatabaseStatus * | status | ) |
| pure virtual

cancel the ongoing FIND request, stop and reset every running operation associated with this request, delete existing temporary files.

Parameters

  status | pointer to DB status object in which a DIMSE status code suitable for use with the C-FIND-RSP message is set.

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ cancelMoveRequest()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::cancelMoveRequest | ( | DcmQueryRetrieveDatabaseStatus * | status | ) |
| pure virtual

cancel the ongoing MOVE request, stop and reset every running operation associated with this request, delete existing temporary files.

Parameters

  status | pointer to DB status object in which a DIMSE status code suitable for use with the C-MOVE-RSP message is set.

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ makeNewStoreFileName()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::makeNewStoreFileName | ( | const char * | SOPClassUID,
|  | const char * | SOPInstanceUID,
|  | char * | newImageFileName,
|  | size_t | newImageFileNameLen )
| pure virtual

create a filename under which a DICOM object that is currently being received through a C-STORE operation can be stored.

Parameters

  SOPClassUID | SOP class UID of DICOM instance
  SOPInstanceUID | SOP instance UID of DICOM instance
  newImageFileName | file name is returned in this parameter. Memory must be provided by the caller and should be at least MAXPATHLEN+1 characters. The file name generated should be an absolute file name.
  newImageFileNameLen | length of buffer pointed to by newImageFileName

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ nextFindResponse()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::nextFindResponse | ( | DcmDataset ** | findResponseIdentifiers,
|  | DcmQueryRetrieveDatabaseStatus * | status,
|  | const DcmQueryRetrieveCharacterSetOptions & | characterSetOptions )
| pure virtual

return the next available FIND response as a new DICOM dataset.

Parameters

  findResponseIdentifiers | DICOM dataset returned in this parameter. The caller is responsible for destroying the findResponseIdentifiers when no longer needed.
  status | pointer to DB status object in which a DIMSE status code suitable for use with the C-FIND-RSP message is set. Status will be PENDING if more FIND responses will be generated or SUCCESS if no more FIND responses will be generated (SUCCESS indicates the completion of a operation), or another status code upon failure.
  characterSetOptions | the character set options for response conversion etc.

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ nextMoveResponse()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::nextMoveResponse | ( | char * | SOPClassUID,
|  | size_t | SOPClassUIDSize,
|  | char * | SOPInstanceUID,
|  | size_t | SOPInstanceUIDSize,
|  | char * | imageFileName,
|  | size_t | imageFileNameSize,
|  | unsigned short * | numberOfRemainingSubOperations,
|  | DcmQueryRetrieveDatabaseStatus * | status )
| pure virtual

Constructs the information required for the next available C-MOVE sub-operation (the image SOP class UID, SOP Instance UID and an imageFileName containing the requested data).

Parameters

  SOPClassUID | pointer to string of at least 65 characters into which the SOP class UID for the next DICOM object to be transferred is copied.
  SOPClassUIDSize | size of SOPClassUID element
  SOPInstanceUID | pointer to string of at least 65 characters into which the SOP instance UID for the next DICOM object to be transferred is copied.
  SOPInstanceUIDSize | size of SOPInstanceUID element
  imageFileName | pointer to string of at least MAXPATHLEN+1 characters into which the file path for the next DICOM object to be transferred is copied.
  imageFileNameSize | size of imageFileName element
  numberOfRemainingSubOperations | On return, this parameter will contain the number of suboperations still remaining for the request (this number is needed by move responses with PENDING status).
  status | pointer to DB status object in which a DIMSE status code suitable for use with the C-MOVE-RSP message is set. Status will be PENDING if more MOVE responses will be generated or SUCCESS if no more MOVE responses will be generated (SUCCESS indicates the completion of a operation), or another status code upon failure.

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ pruneInvalidRecords()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::pruneInvalidRecords | ( |  | ) |
| pure virtual

Prune invalid records from the database.

Records referring to non-existent image files are invalid.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ setIdentifierChecking()

virtual void DcmQueryRetrieveDatabaseHandle::setIdentifierChecking | ( | OFBool | checkFind,
|  | OFBool | checkMove )
| pure virtual

Configure the DB module to perform (or not perform) checking of FIND and MOVE request identifiers.

Default is no checking.

Parameters

  checkFind | checking for C-FIND parameters
  checkMove | checking for C-MOVE parameters

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ startFindRequest()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::startFindRequest | ( | const char * | SOPClassUID,
|  | DcmDataset * | findRequestIdentifiers,
|  | DcmQueryRetrieveDatabaseStatus * | status )
| pure virtual

initiate FIND operation using the given SOP class UID (which identifies the query model) and DICOM dataset containing find request identifiers.

Parameters

  SOPClassUID | SOP class UID of query service, identifies Q/R model
  findRequestIdentifiers | dataset containing request identifiers (i.e., the query) The caller retains responsibility for destroying the findRequestIdentifiers when no longer needed.
  status | pointer to DB status object in which a DIMSE status code suitable for use with the C-FIND-RSP message is set. Status will be PENDING if any FIND responses will be generated or SUCCESS if no FIND responses will be generated (SUCCESS indicates the completion of a operation), or another status code upon failure.

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ startMoveRequest()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::startMoveRequest | ( | const char * | SOPClassUID,
|  | DcmDataset * | moveRequestIdentifiers,
|  | DcmQueryRetrieveDatabaseStatus * | status )
| pure virtual

initiate MOVE operation using the given SOP class UID (which identifies the retrieve model) and DICOM dataset containing move request identifiers.

Parameters

  SOPClassUID | SOP class UID of retrieve service, identifies Q/R model
  moveRequestIdentifiers | dataset containing request identifiers (i.e., the query) The caller retains responsibility for destroying the moveRequestIdentifiers when no longer needed.
  status | pointer to DB status object in which a DIMSE status code suitable for use with the C-MOVE-RSP message is set. Status will be PENDING if any MOVE responses will be generated or SUCCESS if no MOVE responses will be generated (SUCCESS indicates the completion of a operation), or another status code upon failure.

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

## ◆ storeRequest()

virtual OFCondition DcmQueryRetrieveDatabaseHandle::storeRequest | ( | const char * | SOPClassUID,
|  | const char * | SOPInstanceUID,
|  | const char * | imageFileName,
|  | DcmQueryRetrieveDatabaseStatus * | status,
|  | OFBool | isNew = OFTrue )
| pure virtual

register the given DICOM object, which has been received through a C-STORE operation and stored in a file, in the database.

Parameters

  SOPClassUID | SOP class UID of DICOM instance
  SOPInstanceUID | SOP instance UID of DICOM instance
  imageFileName | file name (full path) of DICOM instance
  status | pointer to DB status object in which a DIMSE status code suitable for use with the C-STORE-RSP message is set.
  isNew | if true, the instance is marked as "new" in the database, if such a flag is maintained in the database.

Returns
  EC_Normal upon normal completion, or some other OFCondition code upon failure.

Implemented in DcmQueryRetrieveIndexDatabaseHandle.

The documentation for this class was generated from the following file:

- dcmqrdb/include/dcmtk/dcmqrdb/dcmqrdba.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2